#pragma once
#include "Vei2.h"

class Camera
{
private:
	static constexpr int CTRKOFFVERT = 50;
	static constexpr int CTRKOFFHOR = 240;
public:
	static constexpr int  WORLDWIDTH = 2000;
	static constexpr int WORLDHEIGHT = 1199;

public:

	Vei2 pos;

	void Update(Vei2 playerPos, int playerWidth, int playerHeight)
	{
		// convert player world coordinates to screen coordinates
		int px = playerPos.x - pos.x;
		int py = playerPos.y - pos.y;
		int width = playerWidth;
		int height = playerHeight;
		int ScreenWidth = 800;
		int ScreenHeight = 600;

		// scroll camera if player is out of tracking rectangle
		if (px < CTRKOFFHOR)
		{
			pos.x = playerPos.x - CTRKOFFHOR;
		}
		if (px + width > ScreenWidth - CTRKOFFHOR)
		{
			pos.x = playerPos.x + width + CTRKOFFHOR - ScreenWidth;
		}
		if (py < CTRKOFFVERT)
		{
			pos.y = playerPos.y - CTRKOFFVERT;
		}
		if (py + height > ScreenHeight - CTRKOFFVERT)
		{
			pos.y = playerPos.y + height + CTRKOFFVERT - ScreenHeight;
		}

		// clamp camera so that the screen does not exceed
		// the edge of the world
		if (pos.x < 0)
		{
			pos.x = 0;
		}
		else if (pos.x + ScreenWidth > WORLDWIDTH)
		{
			pos.x = WORLDWIDTH - ScreenWidth;
		}
		if (pos.y < 0)
		{
			pos.y = 0;
		}
		else if (pos.y + ScreenHeight > WORLDHEIGHT)
		{
			pos.y = WORLDHEIGHT - ScreenHeight;
		}
	}
};