#pragma once
#include "Graphics.h"
#include "Keyboard.h"
#include "Vec2.h"
#include "Surface.h"

class Player
{
public:
	
	Player();
	void Draw(Graphics& gfx) const;
	void Update(const Keyboard& kbd);
	float GetPosX() const;
	float GetPosY() const;
	float GetWidth() const;
	float GetHeight() const;
	int GetCameraX() const;
	int GetCameraY() const;

private:
	
	void Controls(const Keyboard& kbd);
	void UpdateCamera(int playerX, int playerY);
	void ClampToScreen();

	float x, y, width, height, speedX, speedY, gravity;
	float angle = 0.0f;
	float movementAngle = 0.0f;
	int cameraX, cameraY;
	static constexpr float PI = 3.14;
	static constexpr int CTRKOFFVERT = 50;
	static constexpr int CTRKOFFHOR = 240;
	static constexpr int  WORLDWIDTH = 4000;
	static constexpr int WORLDHEIGHT = 1199;
	static constexpr float speed = 3.0f;

};
